﻿using System;
using System.IO;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Xml.Serialization;
using System.Threading;

namespace XmsDemo
{
    
    public partial class XmsDemoForm : Form
    {
        private static EventHandler m_EventHandler = new EventHandler();
        private string m_txtMessage;
        public delegate void AddToList();
        public AddToList tsDelegate; // thread-safe deleage to add strings to the list boxes
        private static bool m_request = true;
         
        
        public XmsDemoForm()
        {
            InitializeComponent();
            Logger.Init("CsDemo.log", this);
            m_txtMessage = new string(' ', 1024);
            tsDelegate = new AddToList(AddToListMethod);

        }

        private void XmsDemoForm_Load(object sender, EventArgs e)
        {
            txtUri.Text = "192.168.0.105"; //"146.152.64.103";// 
            txtAppId.Text = "app";
            txtPort.Text = "81";
            txtCallAddress.Text = "sip:test@192.168.0.104"; //10.20.105.54"
            btnMakeCall.Enabled = false;
            btnStart.Tag = this; // just something other than null, start/stop switch
        }

        private void btnStart_Click(object sender, EventArgs e)
        {
            if (btnStart.Tag != null)
            {

                Program.g_XmsIf = new XmsInterface(txtUri.Text, txtPort.Text, txtAppId.Text);

                if (m_EventHandler.Create(txtRequest.Text) != 0)
                {
                    MessageBox.Show("Can't create event handler, check connection info", "", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    Logger.Log("ERROR creating event handler, see the logs", false);
                    return;
                }
                CallManager.Start();
//                this.FormBorderStyle = FormBorderStyle.None;
                this.MaximizeBox = false;
                this.MinimizeBox = false;
                
  //              this.StartPosition = FormStartPosition.CenterScreen;
                this.ControlBox = false;
                btnStart.Text = "Exit";
                btnStart.Tag = null;
                btnMakeCall.Enabled = true;
            }
            else
            {
                CallManager.Stop();
                m_EventHandler.Destroy();
                Thread.Sleep(300);
                this.Close();
            }
        }



        public void AddToListMethod()
        {
            ToScreen();
        }


        public int WriteMessage(string a_message, bool a_request)
        {
            m_request = a_request;
            m_txtMessage = a_message;
            if (txtRequest.InvokeRequired)
            {
                return -1; // the calling thread will try to invoke the delegate
            }
            ToScreen();
            return 0;
        }

        private void ToScreen()
        {
            try
            
            
            {
                if (!m_request)
                {
                    m_txtMessage = "   <-- " + m_txtMessage;
                }
                else
                    m_txtMessage = "--> " + m_txtMessage;
                if (m_txtMessage.ToLower().Contains("err") || m_txtMessage.ToLower().Contains("fail"))
                    m_txtMessage = "   *** " + m_txtMessage;
                txtRequest.AppendText(m_txtMessage + "\r\n");
            }
            finally
            {
            }

        }


        private void btnMakeCall_Click(object sender, EventArgs e)
        {
            if (txtCallAddress.Text == "" || txtCallAddress.Text.Length < 10)
            {
                MessageBox.Show("Please enter valid destination address to call to", "",
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }
            if (CallManager.MakeCall(txtCallAddress.Text) == -1)
            {
                MessageBox.Show("Call failed to initiate, check the log", "",
                    MessageBoxButtons.OK, MessageBoxIcon.Warning);
            }
        }

    }
}
